﻿using CanonSharp.Pascal.Scanner;

namespace CanonSharp.Pascal.SyntaxTree;

public sealed class ForNode(
    LexicalToken identifier,
    SyntaxNodeBase leftCondition,
    SyntaxNodeBase rightCondition,
    SyntaxNodeBase statement) : SyntaxNodeBase
{
    public override SyntaxNodeType NodeType => SyntaxNodeType.For;

    public LexicalToken Identifier => identifier;

    public SyntaxNodeBase LeftCondition => leftCondition;

    public SyntaxNodeBase RightCondition => rightCondition;

    public SyntaxNodeBase Statement => statement;
}
