﻿using CanonSharp.Pascal.Scanner;

namespace CanonSharp.Pascal.SyntaxTree;

public sealed class ProcedureCallNode : SyntaxNodeBase
{
    public ProcedureCallNode(LexicalToken identifier, IEnumerable<SyntaxNodeBase> parameters)
    {
        Identifier = identifier;
        Parameters.AddRange(parameters);
    }

    public override SyntaxNodeType NodeType => SyntaxNodeType.ProcedureCall;

    public LexicalToken Identifier { get; }

    public List<SyntaxNodeBase> Parameters { get; } = [];
}
