using CanonSharp.Combinator.Extensions;
using CanonSharp.Pascal.Scanner;

namespace CanonSharp.Tests.ReaderTests;

public class StringReadStateTests
{
    [Fact]
    public void AsEnumerableTest()
    {
        StringReadState state = new("abc");

        IEnumerable<StringReadState> states = state.AsEnumerable<char, StringReadState>();

        foreach ((char c, StringReadState s) in "abc".Zip(states))
        {
            Assert.True(s.HasValue);
            Assert.Equal(c, s.Current);
        }
    }
}
